# remirepo/Fedora spec file for php-zendframework-zend-json-server
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    98b31e114661b2be103c82bd9c593fb027fe2371
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-json-server
%global php_home     %{_datadir}/php
%global library      Server
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        3.1.0
Release:        3%{?dist}
Summary:        Zend Json-Server is a JSON-RPC server implementation

License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-pcre
BuildRequires:  php-reflection
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.2",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires:  (php-autoloader(%{gh_owner}/zend-http)             >= 2.7   with php-autoloader(%{gh_owner}/zend-http)             < 3)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-json)             >= 3.0   with php-autoloader(%{gh_owner}/zend-json)             < 4)
BuildRequires:  (php-autoloader(%{gh_owner}/zend-server)           >= 2.7   with php-autoloader(%{gh_owner}/zend-server)           < 3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.2
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-http": "^2.7",
#        "zendframework/zend-json": "^2.6.1 || ^3.0",
#        "zendframework/zend-server": "^2.7"
Requires:       php(language) >= 5.6
# Require zend-json 3.0.0 as conflicts with previous
Requires:       (php-autoloader(%{gh_owner}/zend-http)             >= 2.7   with php-autoloader(%{gh_owner}/zend-http)             <  3)
Requires:       (php-autoloader(%{gh_owner}/zend-json)             >= 3.0   with php-autoloader(%{gh_owner}/zend-json)             <  4)
Requires:       (php-autoloader(%{gh_owner}/zend-server)           >= 2.7   with php-autoloader(%{gh_owner}/zend-server)           <  4)
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 3.0.0
Requires:       php-pcre
Requires:       php-reflection
Requires:       php-spl

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Provides a JSON-RPC server implementation.

* File issues at https://github.com/zendframework/zend-json-server/issues
* Documentation is at http://framework.zend.com/manual/current/en/index.html#zend-json-server


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/Json/autoload.php',
    '%{php_home}/Zend/Http/autoload.php',
    '%{php_home}/Zend/Server/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/Json
cp -pr src %{buildroot}%{php_home}/Zend/Json/%{library}


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/Json/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\Json\\%{library}\\', dirname(__DIR__) . '/test');
require_once __DIR__ . '/../test/TestAsset/FooFunc.php';
EOF

ret=0
for cmdarg in "php %{phpunit}" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/Json/%{library}


%changelog
* Sat Feb 02 2019 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_30_Mass_Rebuild

* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.1.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Thu Apr 26 2018 Remi Collet <remi@remirepo.net> - 3.1.0-1
- update to 3.1.0
- raise dependency on PHP 5.6
- raise dependency on zend-http 2.7
- raise dependency on zend-server 2.7
- switch to phpunit7
- use range dependencies

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sat Dec  9 2017 Remi Collet <remi@remirepo.net> - 3.0.0-4
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 3.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 3.0.0-1
- initial package
